



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>为IEnumerable扩展一个ForEach方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">为IEnumerable扩展一个ForEach方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 13:05:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>IEnumerable没有一个ForEach方法，我们可以使用C#写一个扩展方法：<br /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/28036/201604/28036-20160401083201473-939763494.png" /></p>
<p>Source Code:</p>
<div>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Threading.Tasks;

namespace Insus.NET.ExtendMethods<br />
{<br />
  public static class Enumerables<br />
    {<br />
        public static void ForEach&lt;T&gt;(this IEnumerable&lt;T&gt; source, Action&lt;T&gt; action)<br />
        {<br />
            foreach (T item in source)<br />
            {<br />
                action(item);<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>下例中，Insus.NET列举一个IEnumerable数据集，然后使用这个方法来获取其中的元素：<br /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/28036/201604/28036-20160401083535644-1351222237.png" /></p>
<p>Source Code:</p>
<div>
<div>
<pre class="prettyprint linenums">public IEnumerable&lt;IDictionary&lt;string, object&gt;&gt; Links()<br />
        {<br />
            var dict = new Dictionary&lt;string, object&gt;();<br />
            dict["Index"] = "新产品介绍";<br />
            dict["Manufacturing"] = "制造能力/流程";<br />
            dict["DieCasting"] = "压铸";<br />
            dict["Machining"] = "加工";<br />
            dict["AssemblyFinishing"] = "组装&amp;成品";<br />
            dict["TestReliability"] = "测试和可靠性";<br />
            dict["KeyCustomer"] = "关键客户";<br />
            yield return dict;<br />
        }</pre>
</div>
</div>
<p>ForEach方法应用：<br /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/28036/201604/28036-20160401084033082-728832377.png" /></p>
<p>Source Code:</p>
<div>
<div>
<pre class="prettyprint linenums">obj.Links().ForEach(delegate (IDictionary&lt;string, object&gt; dict) {<br />
            foreach (KeyValuePair&lt;string, object&gt; kvp in dict)<br />
            {<br />
                    //kvp.Key<br />
                    //kvp.Value<br />
            }<br />
        });</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495p20qz.html">APEX&colon;对object中数据进行简单处理？</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8okyre9.html">Linux下Source Insight的安装和汉化</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g34dzq.html">PropertiesFactoryBean PropertyPlaceholderConfigurer 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jp6kl9.html">AJAX格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0g5z8.html">【PyQt5】学习笔记（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5vor8.html">cocos2d-lua 3&period;5 android搭建步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okv6ol9.html">DOM-判断元素节点类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdegkgj9.html">【转】MySQL的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x6e6n9.html">uCOS-II任务的挂起和恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6dx49.html">iOS 关于枚举的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoy0jdq.html">ASP&period;NET MVC2&period;0学习笔记：路由设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojy4veq.html">Django 学习笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj7r719.html">康盛（discuz ）牛逼的PHP加解密算法函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp34o7q.html">A Dream &lpar;PKUWC 2018&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p23xv8.html">小细节，大用途，35 个 Java 代码性能优化总结！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6gvj9.html">vue中简单的小插曲</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzd2r9.html">使用Linux脚本更新Weblogic部署的应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6pm19.html">Codeforces 959F Mahmoud and Ehab and yet another xor task 线性基 &lpar;看题解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywwrgq.html">self study 权限 permission</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ome6k8.html">C语言的AT指令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qy6j7x8.html">《你必须知道的&period;NET》读书笔记：方法表初窥</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r62n79.html">Angularjs中文版本开发指南发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y705q.html">JavaScript思维导图&mdash;运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kk74j8.html">科蓝软件急招前端开发、PHP、&period;NET工程师</a>
			</li>
						<li><a href="https://www.batexi.com/a/r933m5z9.html">IOS Block-Block块的使用与理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kky538.html">iOS  ARC模式 内存管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy6mng8.html">Redis教程&lpar;十三&rpar;：管线详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gzl178.html">爱上MVC3~在控制器或Action上动态设定模板页&lpar;Layout&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mygnp8.html">爱上MVC~在Views的多级文件夹~续~分部页的支持</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlpmnx9.html">Spring配置汇总</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
